DECLARE FUNCTION ConvertDoublePrecisionToDollars# (a#)

'foreign tax credit
'This program helps fill out form 1116 of the USA Internal Revenue Service,
'the foreign tax credit.  It works for years 1995 and 1996, probably
'works for previous years as well, and will probably continue to work
'until major changes are made to form 1116.

'This program was written and tested with Qbasic from MS DOS 5.00,
'running under DR DOS 6.0, on a 386SX/16 with 2M of RAM.  I think
'this will work with any version of Qbasic, and I think you can use
'any version of DOS and any computer that will run Qbasic.  I think
'this program will also run with PowerBasic 3, and it might run with
'later versions of QuickBasic.

'This program was written by Kenneth Howlett, March 1997.
'It is free and you can do anything you want with it.

'I wrote this program by following the directions for form 1116.  If I
'misunderstood the directions, then the program will be wrong, and so
'will your tax return, and so will my tax return, and we will both go
'to jail.  If you are worried about the possibility of becoming my
'cellmate, then hire an accountant instead of using this program.
'In other words, I do NOT guarantee that this program fills out form
'1116 correctly.

'This program assumes that all foreign income came from, and all
'foreign taxes were paid by, one, and only one, mutual fund.  If this
'assumption is not true, this program will not work right.

'This program assumes that you are going to list each country
'separately, which the IRS requires if you paid more than $200 in
'foreign taxes.  If you paid less than $200 in taxes and are not
'going to list each country seperately, you can skip some parts;
'for example, skip filling our columns B and C, and skip the part
'about copying form 1116; and when the program asks what percent of
'taxes was paid to this country, enter 100.

'Before you begin you need to know how much income came from, and how
'much taxes were paid to, each country.  You should have a list saying
'Argentina, .70% of income, .13% of taxes; Australia, 1.78% of income,
'.98% of taxes; etc.

'If your mutual fund is well diversified, it will have invested in
'many different countries, and will probably have paid taxes to
'many different countries.  You can only list three countries on
'each form 1116, so you will have to fill out several copies.  Half
'the stuff is the same on every copy.  So we will save some writing
'by first filling out the stuff that is the same, then making copies
'of the partially completed form 1116, and then filling out the rest.

'Take a blank form 1116.  Fill in your name, social security number,
'check the box beside Passive Income, and write USA where it says
'resident of.  If Passive Income and USA are wrong for you, this
'program may not work right. Write "mutual fund distributions" on
'the dotted line beside/under item 1, part I.  Fill out columns A,
'B, and C of lines 2, 3a, 3b, 3c, 3e, 4a, 4b, and 5.  This program
'assumes that these lines will be the same for all countries, and
'that lines 2, 4a, 4b, and 5 all are $0.  If that is not
'true, this program will not work right.  Now change the next
'two lines of the program to the numbers you wrote on form 1116
'in lines 3c and 3e:
Line3c# = 8820.200000000001#
Line3e# = 35403.32#

'You should end the numbers with #; this makes the calculations more
'accurate.

'For form 1116, part II, lines A, B, and C, column m, write
'"12-31-96 form 1099", but use the correct year if you are not
'doing your 1996 taxes.

'Now make copies of your partially completed form 1116.  You do not
'have to copy the back side.

'Now go to parts III and IV of the original and fill out lines 10, 12,
'15, 17, 19, and 31.  Enter your results into the program on the next
'six lines:
Line10# = 0#
Line12# = 0#
Line15# = 0#
Line17# = 15526.368#
Line19# = 2740.106#
Line31# = 0#

'Get the form 1099-DIV for the mutual fund and get the numbers from
'1b, ordinary dividends; and 3, foreign tax paid.  Enter these numbers
'into the program on the next two lines:
Form1099Item1b# = 4845.775#
Form1099Item3# = 255.26#

'A brief comment on the last part: T Rowe Price advises shareholders
'to use the number in 1b to calculate foreign income; which seems to
'imply that dividends from foreign stocks are foreign income, but capital
'gains on foreign stocks are not foreign income.  But the instructions
'for form 1116 mention capital gains while discussing foreign income,
'which suggests to me that capital gains on foreign stocks are foreign
'income.  So maybe you could use
'the number in 1a, minus the number in 1d, instead of the number in 1b.
'Or maybe, if the mutual fund says that 80% of the income came from
'foreign sources, that means 80% of the number in 1b plus 100% of the
'number in 1c; in which case you should use:
'Form1099Item1b# = (number in 1c) * 100# / (percent of income from foreign sources) + (number in 1b)
'Using a bigger number may give you a bigger credit, or it might have
'no effect.


'OK, you are ready to run the program.  Write the name of the first
'or next country on your list onto form 1116, part I, line j.  The
'program will ask you what percent of income came from this country,
'and what percent of tax was paid to this country.  Then it will tell
'you what to write on the next line and pause.  Write the number and
'then press any key, and then it will tell you the next line.  The
'program does most of the calculations while it waits for you to write
'the last number, which creates the illusion of blinding speed.

'When you are finished with a country, you will have a choice of doing
'another country or doing the totals.  If you want to do the totals
'but the program starts another country, just press enter when the
'program asks what percentage and keep going until you get back to
'the totals prompt.  If you want to do another country but the program
'does the totals, just keep going; at the end you will have the option
'of doing another country.  Note that you can not save your work.
'Once you start, you have to keep going until you finish.  You can quit
'anytime by pressing [ESCAPE], but once you stop the program, you have
'to go back to the beginning and start again.

'If you received income from a country but paid no tax to that country,
'list the country anyway; it might increase the size of your credit,
'or it might have no effect.


' Press F5 to begin.









'press escape to abort
KEY 15, CHR$(0) + CHR$(1): ON KEY(15) GOSUB SomeonePressedEscape: KEY(15) ON
KEY 16, CHR$(32) + CHR$(1): ON KEY(16) GOSUB SomeonePressedEscape: KEY(16) ON
KEY 17, CHR$(64) + CHR$(1): ON KEY(17) GOSUB SomeonePressedEscape: KEY(17) ON
KEY 18, CHR$(96) + CHR$(1): ON KEY(18) GOSUB SomeonePressedEscape: KEY(18) ON


TotalForLine1# = 0#
TotalForLine6# = 0#
TotalForLine8# = 0#

CLS


NextCountry:
PRINT
PRINT
PRINT "write the name of the country on line j in part I"
PRINT

DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "what percent of the income came from this country?"
PRINT "(enter 10.16% as 10.16; enter .37% as .37; etc)"
PRINT
INPUT a#

PRINT
PRINT "what percent of the tax was paid to this country?"
PRINT "(enter 10.16% as 10.16; enter .37% as .37; etc)"
PRINT
INPUT PercentageOfTaxPaidToThisCountry#

a# = a# * Form1099Item1b# / 100#
TotalForLine1# = TotalForLine1# + a#
PRINT
PRINT "line 1 and line 3d are:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT

a# = a# / Line3e#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 3f is:  ";
PRINT a#
PRINT

a# = a# * Line3c#
TotalForLine6# = TotalForLine6# + a#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "lines 3g and 6 are:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT

a# = Form1099Item3# * PercentageOfTaxPaidToThisCountry# / 100#
TotalForLine8# = TotalForLine8# + a#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "column v in part II is:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT

WhichRoutineNext:
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT
PRINT
PRINT "add up the totals or go on to the next country?"
PRINT "press t for the totals, press [ESCAPE] to quit,"
PRINT "press q for a quick summary of how large your credit is so far,"
PRINT "press any other key to do another country"
PRINT
PRINT
PRINT
GetKeyCode:
a$ = INKEY$
a$ = LCASE$(a$)
IF a$ = "q" THEN GOTO QuickSubtotal
IF a$ = "t" THEN GOTO AddUpTotals
IF a$ = "" THEN GOTO GetKeyCode
GOTO NextCountry


AddUpTotals:
PRINT
PRINT "total for line 1 is:  ";
PRINT ConvertDoublePrecisionToDollars#(TotalForLine1#)
PRINT

DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "total for line 6 is:  ";
PRINT ConvertDoublePrecisionToDollars#(TotalForLine6#)
PRINT

a# = TotalForLine1# - TotalForLine6#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 7 is:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT

DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 8 is:  ";
PRINT ConvertDoublePrecisionToDollars#(TotalForLine8#)
PRINT

DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 9 is:  ";
PRINT ConvertDoublePrecisionToDollars#(TotalForLine8#)
PRINT

b# = TotalForLine8# + Line10#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 11 is:  ";
PRINT ConvertDoublePrecisionToDollars#(b#)
PRINT

b# = b# - Line12#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 13 is:  ";
PRINT ConvertDoublePrecisionToDollars#(b#)
PRINT

DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 14 is:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT

a# = a# + Line15#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 16 is:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT

a# = a# / Line17#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 18 is:  ";
PRINT a#
PRINT

a# = a# * Line19#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 20 is:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT

IF b# > a# THEN
  b# = b# - a#
ELSE
  a# = b#
  b# = 0#
END IF
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "lines 21, 22, and 30:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT

a# = a# - Line31#
DO
LOOP UNTIL INKEY$ <> ""
PRINT
PRINT "line 32 is:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT
IF b# > 0# THEN
  DO
  LOOP UNTIL INKEY$ <> ""
  PRINT
  PRINT "You could not use all of your tax credit.   The part which is not"
  PRINT "used can be carried forward to next year.  The amount which you can"
  PRINT "carry forward is:  "; b#
  PRINT
END IF

GOTO WhichRoutineNext


QuickSubtotal:
a# = TotalForLine1# - TotalForLine6#
b# = TotalForLine8# + Line10#
b# = b# - Line12#
a# = a# + Line15#
a# = a# / Line17#
a# = a# * Line19#
IF b# > a# THEN
  b# = b# - a#
ELSE
  a# = b#
  b# = 0#
END IF
a# = a# - Line31#
PRINT
PRINT "so far, your credit is:  ";
PRINT ConvertDoublePrecisionToDollars#(a#)
PRINT
IF b# > 0# THEN
  DO
  LOOP UNTIL INKEY$ <> ""
  PRINT
  PRINT "and your carry-forward is:  ";
  PRINT ConvertDoublePrecisionToDollars#(b#)
  PRINT
END IF

GOTO WhichRoutineNext

SomeonePressedEscape:
END

FUNCTION ConvertDoublePrecisionToDollars# (a#)
'This function rounds double precision numbers to two decimal places.
b# = a# * 100#
c& = b#
d# = c&
IF d# + .5# = b# THEN c& = c& + 1   'this corrects an error in Qbasic
d# = c&
ConvertDoublePrecisionToDollars# = d# / 100#
END FUNCTION

